<?php
// Inject tracking script into head
function trackman_inject_script() {
	if ( ! is_admin() ) {
		if( !get_option( 'trackman_public_key' ) ) {
		?>
			<script type='text/javascript'>
				console.log('❌❌❌ TrackMan: No public key found. Please add your public key in the TrackMan settings page.');
			</script>
		<?php
			// return;
		} else {
			$trackman_public_keys_array = explode( ',', get_option( 'trackman_public_key' ) );			
		?>

		<script type='text/javascript'>
			(function (d, s, id) {
				var js, fjs = d.getElementsByTagName(s)[0];
				if (d.getElementById(id)) return;
				js = d.createElement(s); js.id = id;
				js.src = "https://app.adtechthai.com/js/1.0/adtech-tracker.js";
				fjs.parentNode.insertBefore(js, fjs);
			}(document, 'script', 'adtech-tracker'));
			var trackManPublicKey = "<?php echo esc_attr( get_option( 'trackman_public_key' ) ); ?>";
			window.addEventListener("load", function (event) {
				adTechBaseUrl = "https://app.adtechthai.com";
			<?php
				foreach( $trackman_public_keys_array as $trackman_public_key ) {
					echo "adTechTrackerInit('" . $trackman_public_key . "');";
				}
			?>
			});
		</script>
		<?php
		}
	}
}
add_action( 'wp_head', 'trackman_inject_script', 1 );